/// @cond EO_CXX_EO_IMPL

inline Elm_Bubble_Pos elm::bubble::pos_get() const
{
   Elm_Bubble_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_bubble_pos_get());
   return _tmp_ret;
}

inline void elm::bubble::pos_set(Elm_Bubble_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bubble_pos_set(pos_));
}

inline Elm_Bubble_Pos eo_cxx::elm::bubble::pos_get() const
{
   Elm_Bubble_Pos _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_bubble_pos_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::bubble::pos_set(Elm_Bubble_Pos pos_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_bubble_pos_set(pos_));
}

inline ::eo_cxx::elm::bubble::operator ::elm::bubble() const
{
   return *static_cast<::elm::bubble const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::bubble::operator ::elm::bubble&()
{
   return *static_cast<::elm::bubble*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::bubble::operator ::elm::bubble const&() const
{
   return *static_cast<::elm::bubble const*>(static_cast<void const*>(this));
}

template <typename T>
Elm_Bubble_Pos elm_bubble_pos_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->pos_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Bubble_Pos _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_bubble_pos_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Bubble_Pos pos_)
{
   try
      {
         static_cast<T*>(self->this_)->pos_set(pos_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::bubble >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
   {
      virtual Elm_Bubble_Pos pos_get()
      {
         Elm_Bubble_Pos _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_bubble_pos_get());
            return _tmp_ret;
      }

      virtual void pos_set(Elm_Bubble_Pos pos_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_bubble_pos_set(pos_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::bubble >
{
   static constexpr int value = 
#if defined(BUBBLE_PROTECTED) && defined(BUBBLE_BETA)
      2
#elif defined(BUBBLE_PROTECTED)
      2
#elif defined(BUBBLE_BETA)
      2
#else
      2
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::evas::clickable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::bubble>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_bubble_pos_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_bubble_pos_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_bubble_pos_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_bubble_pos_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::bubble >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::bubble >::value + operation_description_class_size<::elm::layout>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::bubble>)
{
   return (ELM_BUBBLE_CLASS);
}

} } }

/// @endcond

